package com.younike.common.wxpay.pojo;

import lombok.Data;

/**
 * @author yangby
 * @description 微信转账
 * @date 2021/9/6
 */
@Data
public class WechatTransfer {

    // 申请商户号的appid或商户号绑定的appid
    private String mch_appid;

    // 微信支付分配的商户号
    private String mchid;

    // 随机字符串，不长于32位
    private String nonce_str;

    private String sign;//签名

    // 商户订单号，需保持唯一性(只能是字母或者数字，不能包含有其他字符)
    private String partner_trade_no;

    // 商户appid下，某用户的openid
    private String openid;

    // NO_CHECK：不校验真实姓名 FORCE_CHECK：强校验真实姓名
    private String check_name = "NO_CHECK";

    // 企业付款金额，单位为分
    private String amount;

    // 企业付款备注,注意：备注中的敏感词会被转成字符*
    private String desc;

    // 发起者IP地址+该IP可传用户端或者服务端的IP。支持IPV4和IPV6两种格式的IP地址。
    //private String spbill_create_ip;
}
