package com.younike.service.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.younike.common.core.page.PageParam;
import com.younike.service.pojo.SysOperLog;
import org.apache.ibatis.annotations.Param;

/**
 * 操作日志 数据层
 */
public interface SysOperLogMapper {
    /**
     * 新增操作日志
     *
     * @param operLog 操作日志对象
     */
    void insertOperlog(SysOperLog operLog);

    /**
     * 查询系统操作日志集合
     *
     *
     * @param pageParam
     * @param operLog 操作日志对象
     * @return 操作日志集合
     */
    Page<SysOperLog> selectOperLogList(PageParam pageParam, @Param("operLog") SysOperLog operLog);

    /**
     * 批量删除系统操作日志
     *
     * @param ids 需要删除的数据
     * @return 结果
     */
    int deleteOperLogByIds(String[] ids);

    /**
     * 查询操作日志详细
     *
     * @param operId 操作ID
     * @return 操作日志对象
     */
    SysOperLog selectOperLogById(Long operId);

    /**
     * 清空操作日志
     */
    void cleanOperLog();
}
