package com.younike.service.pojo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.Version;
import com.younike.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * app用户对象 t_app_user
 *
 * @author jiay
 * @date 2022-02-25
 */
@Data
public class TAppUser extends BaseEntity {
    private static final long serialVersionUID=1L;

    /** $column.columnComment */
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    /** 手机号 */
    @ApiModelProperty("手机号")
    private String phone;

    /** 微信opid */
    @ApiModelProperty("微信opid")
    private String openId;

    /** 头像 */
    @ApiModelProperty("头像")
    private String avatar;

    /** 昵称 */
    @ApiModelProperty("昵称")
    private String nikeName;

    @ApiModelProperty("钱包余额")
    private BigDecimal amount;

    @ApiModelProperty("冻结金额")
    private BigDecimal forzeAmount;

    /** 删除标志 */
    private String isDel;

    /** 版本号 */
    @Version
    private Long version;

    private String comName;

    private String houseName;

}
